diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/multi-user-scheduler.h ns-3.44/src/wifi/model/he/multi-user-scheduler.h
--- ns-3.43/src/wifi/model/he/multi-user-scheduler.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/multi-user-scheduler.h	2025-03-09 16:55:49.791372500 -0700
@@ -17,6 +17,7 @@
 #include "ns3/wifi-remote-station-manager.h"
 #include "ns3/wifi-tx-parameters.h"
 
+#include <functional>
 #include <unordered_map>
 #include <vector>
 
@@ -25,10 +26,8 @@
 
 class HeFrameExchangeManager;
 
-typedef std::unordered_map<uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
-
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * MultiUserScheduler is an abstract base class defining the API that APs
  * supporting at least VHT can use to determine the format of their next transmission.
@@ -42,8 +41,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     MultiUserScheduler();
@@ -77,15 +76,15 @@
      * Notify the Multi-user Scheduler that the given AC of the AP gained channel
      * access. The Multi-user Scheduler determines the format of the next transmission.
      *
-     * \param edca the EDCAF which has been granted the opportunity to transmit
-     * \param availableTime the amount of time allowed for the frame exchange. Pass
+     * @param edca the EDCAF which has been granted the opportunity to transmit
+     * @param availableTime the amount of time allowed for the frame exchange. Pass
      *                      Time::Min() in case the TXOP limit is null
-     * \param initialFrame true if the frame being transmitted is the initial frame
+     * @param initialFrame true if the frame being transmitted is the initial frame
      *                     of the TXOP. This is used to determine whether the TXOP
      *                     limit can be exceeded
-     * \param allowedWidth the allowed width for the next transmission
-     * \param linkId the ID of the link over which channel access was gained
-     * \return the format of the next transmission
+     * @param allowedWidth the allowed width for the next transmission
+     * @param linkId the ID of the link over which channel access was gained
+     * @return the format of the next transmission
      */
     TxFormat NotifyAccessGranted(Ptr<QosTxop> edca,
                                  Time availableTime,
@@ -97,8 +96,8 @@
      * Get the information required to perform a DL MU transmission on the given link. Note
      * that this method can only be called if GetTxFormat returns DL_MU_TX on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the information required to perform a DL MU transmission
+     * @param linkId the ID of the given link
+     * @return the information required to perform a DL MU transmission
      */
     DlMuInfo& GetDlMuInfo(uint8_t linkId);
 
@@ -106,22 +105,52 @@
      * Get the information required to solicit an UL MU transmission on the given link. Note
      * that this method can only be called if GetTxFormat returns UL_MU_TX on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the information required to solicit an UL MU transmission
+     * @param linkId the ID of the given link
+     * @return the information required to solicit an UL MU transmission
      */
     UlMuInfo& GetUlMuInfo(uint8_t linkId);
 
     /**
+     * This method is called when a protection mechanism for an MU transmission is completed and
+     * gives the MU scheduler the opportunity to modify the MU PPDU or the TX parameters before
+     * the actual MU transmission.
+     *
+     * @param linkId ID of the link on which protection was completed
+     * @param psduMap the PSDU map to be transmitted
+     * @param txParams the TX parameters for the MU transmission
+     */
+    void NotifyProtectionCompleted(uint8_t linkId,
+                                   WifiPsduMap& psduMap,
+                                   WifiTxParameters& txParams);
+
+    /**
+     * When the TXOP limit is zero and the TXOP continues a SIFS after receiving a response to a
+     * BSRP TF, the Duration/ID field of the BSRP TF should be extended to reserve the medium
+     * for the frame exchange following the BSRP TF. This method is intended to return the estimated
+     * duration of the frame exchange following the BSRP TF (including the SIFS after the responses
+     * to the BSRP TF). Specifically, the base class method simply returns the default duration of
+     * TB PPDUs solicited via a Basic Trigger Frame. Subclasses can override this method to return
+     * a more accurate estimate of the time required by the following frame exchange.
+     *
+     * This method should only be called when the MU scheduler has determined that a BSRP TF has
+     * to be sent on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @return the estimated duration of the frame exchange following the BSRP TF
+     */
+    virtual Time GetExtraTimeForBsrpTfDurationId(uint8_t linkId) const;
+
+    /**
      * Set the duration of the interval between two consecutive requests for channel
      * access made by the MultiUserScheduler.
      *
-     * \param interval the duration of the interval between two consecutive requests
+     * @param interval the duration of the interval between two consecutive requests
      *                 for channel access
      */
     void SetAccessReqInterval(Time interval);
 
     /**
-     * \return the duration of the interval between two consecutive requests for channel access
+     * @return the duration of the interval between two consecutive requests for channel access
      */
     Time GetAccessReqInterval() const;
 
@@ -129,36 +158,86 @@
     /**
      * Get the station manager attached to the AP on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the station manager attached to the AP on the given link
+     * @param linkId the ID of the given link
+     * @return the station manager attached to the AP on the given link
      */
     Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager(uint8_t linkId) const;
 
     /**
      * Get the HE Frame Exchange Manager attached to the AP on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the HE Frame Exchange Manager attached to the AP on the given link
+     * @param linkId the ID of the given link
+     * @return the HE Frame Exchange Manager attached to the AP on the given link
      */
     Ptr<HeFrameExchangeManager> GetHeFem(uint8_t linkId) const;
 
     /**
      * Get an MPDU containing the given Trigger Frame.
      *
-     * \param trigger the given Trigger Frame
-     * \param linkId the ID of the link on which the Trigger Frame has to be sent
-     * \return an MPDU containing the given Trigger Frame
+     * @param trigger the given Trigger Frame
+     * @param linkId the ID of the link on which the Trigger Frame has to be sent
+     * @return an MPDU containing the given Trigger Frame
      */
     Ptr<WifiMpdu> GetTriggerFrame(const CtrlTriggerHeader& trigger, uint8_t linkId) const;
 
     /**
+     * Update the given Trigger Frame after protection is completed on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @param trigger the given Trigger Frame
+     * @param txParams the TX parameters for the UL MU transmission
+     */
+    virtual void UpdateTriggerFrameAfterProtection(uint8_t linkId,
+                                                   CtrlTriggerHeader& trigger,
+                                                   WifiTxParameters& txParams) const {};
+
+    /**
+     * Update the given PSDU map after protection is completed on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @param psduMap the given PSDU map
+     * @param txParams the TX parameters for the DL MU transmission
+     */
+    virtual void UpdateDlMuAfterProtection(uint8_t linkId,
+                                           WifiPsduMap& psduMap,
+                                           WifiTxParameters& txParams) const {};
+
+    /**
+     * Remove the User Info fields for which the given predicate is true from the given Trigger
+     * Frame.
+     *
+     * @param linkId the ID of the link on which the Trigger Frame has to be sent
+     * @param trigger the given Trigger Frame
+     * @param txParams the TX parameters for the UL MU transmission
+     * @param predicate the given predicate (input parameters are link ID and device link address)
+     */
+    void RemoveRecipientsFromTf(uint8_t linkId,
+                                CtrlTriggerHeader& trigger,
+                                WifiTxParameters& txParams,
+                                std::function<bool(uint8_t, Mac48Address)> predicate) const;
+
+    /**
+     * Remove PSDUs for which the given predicate is true from the given PSDU map. Entries in the
+     * TXVECTOR corresponding to such PSDUs are also removed.
+     *
+     * @param linkId the ID of the link on which the PSDU map has to be sent
+     * @param psduMap the given PSDU map
+     * @param txParams the TX parameters for the DL MU transmission
+     * @param predicate the given predicate (input parameters are link ID and device link address)
+     */
+    void RemoveRecipientsFromDlMu(uint8_t linkId,
+                                  WifiPsduMap& psduMap,
+                                  WifiTxParameters& txParams,
+                                  std::function<bool(uint8_t, Mac48Address)> predicate) const;
+
+    /**
      * Get the format of the last transmission on the given link, as determined by
      * the last call to NotifyAccessGranted that did not return NO_TX.
      *
-     * \param linkId the ID of the given link
-     * \return the format of the last transmission on the given link
+     * @param linkId the ID of the given link
+     * @return the format of the last transmission on the given link
      */
-    TxFormat GetLastTxFormat(uint8_t linkId);
+    TxFormat GetLastTxFormat(uint8_t linkId) const;
 
     /**
      * Get the maximum size in bytes among the A-MPDUs containing QoS Null frames
@@ -167,8 +246,8 @@
      * QoS Null frames as the number of TIDs for which a BlockAck agreement has
      * been established between the station and the AP.
      *
-     * \param trigger the given Trigger Frame
-     * \return the maximum size in bytes among the A-MPDUs containing QoS Null frames
+     * @param trigger the given Trigger Frame
+     * @return the maximum size in bytes among the A-MPDUs containing QoS Null frames
      *         and solicited by the given Trigger Frame
      */
     uint32_t GetMaxSizeOfQosNullAmpdu(const CtrlTriggerHeader& trigger) const;
@@ -177,18 +256,24 @@
     void NotifyNewAggregate() override;
     void DoInitialize() override;
 
-    Ptr<ApWifiMac> m_apMac; //!< the AP wifi MAC
-    Ptr<QosTxop> m_edca;    //!< the AC that gained channel access
-    Time m_availableTime;   //!< the time available for frame exchange
-    bool m_initialFrame;    //!< true if a TXOP is being started
-    MHz_u m_allowedWidth;   //!< the allowed width for the current transmission
-    uint8_t m_linkId;       //!< the ID of the link over which channel access has been granted
+    Ptr<ApWifiMac> m_apMac;       //!< the AP wifi MAC
+    Ptr<QosTxop> m_edca;          //!< the AC that gained channel access
+    Time m_availableTime;         //!< the time available for frame exchange
+    bool m_initialFrame;          //!< true if a TXOP is being started
+    MHz_u m_allowedWidth;         //!< the allowed width for the current transmission
+    uint8_t m_linkId;             //!< the ID of the link over which channel access has been granted
+    Time m_defaultTbPpduDuration; //!< the default duration of TB PPDUs solicited by Basic TFs
+
+    const std::function<bool(uint8_t, Mac48Address)>
+        m_isUnprotectedEmlsrClient; //!< predicate returning true if the device with the given
+                                    //!< (link) address is an EMLSR client that is not protected on
+                                    //!< the given link
 
   private:
     /**
      * Set the wifi MAC. Note that it must be the MAC of an HE AP.
      *
-     * \param mac the AP wifi MAC
+     * @param mac the AP wifi MAC
      */
     void SetWifiMac(Ptr<ApWifiMac> mac);
 
@@ -197,28 +282,28 @@
      * the given link, such as requesting channel access (if not requested already) and restarting
      * the channel access request timer.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void AccessReqTimeout(uint8_t linkId);
 
     /**
      * Select the format of the next transmission.
      *
-     * \return the format of the next transmission
+     * @return the format of the next transmission
      */
     virtual TxFormat SelectTxFormat() = 0;
 
     /**
      * Compute the information required to perform a DL MU transmission.
      *
-     * \return the information required to perform a DL MU transmission
+     * @return the information required to perform a DL MU transmission
      */
     virtual DlMuInfo ComputeDlMuInfo() = 0;
 
     /**
      * Prepare the information required to solicit an UL MU transmission.
      *
-     * \return the information required to solicit an UL MU transmission
+     * @return the information required to solicit an UL MU transmission
      */
     virtual UlMuInfo ComputeUlMuInfo() = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/mu-snr-tag.h ns-3.44/src/wifi/model/he/mu-snr-tag.h
--- ns-3.43/src/wifi/model/he/mu-snr-tag.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/mu-snr-tag.h	2025-03-09 16:55:49.791372500 -0700
@@ -17,7 +17,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * A tag to be attached to a response to a multi-user UL frame, that carries the SNR
  * values with which the individual frames have been received.
@@ -26,8 +26,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -49,22 +49,22 @@
     /**
      * Set the SNR for the given sender to the given value.
      *
-     * \param staId the STA-ID of the given sender
-     * \param snr the value of the SNR to set in linear scale
+     * @param staId the STA-ID of the given sender
+     * @param snr the value of the SNR to set in linear scale
      */
     void Set(uint16_t staId, double snr);
     /**
      * Return true if the SNR value for the given STA-ID is present
      *
-     * \param staId the STA-ID
-     * \return true if the SNR value for the given STA-ID is present
+     * @param staId the STA-ID
+     * @return true if the SNR value for the given STA-ID is present
      */
     bool IsPresent(uint16_t staId) const;
     /**
      * Return the SNR value for the given sender.
      *
-     * \param staId the STA-ID of the given sender
-     * \return the SNR value in linear scale
+     * @param staId the STA-ID of the given sender
+     * @return the SNR value in linear scale
      */
     double Get(uint16_t staId) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/obss-pd-algorithm.cc ns-3.44/src/wifi/model/he/obss-pd-algorithm.cc
--- ns-3.43/src/wifi/model/he/obss-pd-algorithm.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/obss-pd-algorithm.cc	2025-03-09 16:55:49.791372500 -0700
@@ -88,13 +88,13 @@
 void
 ObssPdAlgorithm::ResetPhy(HeSigAParameters params)
 {
-    dBm_u txPowerMaxSiso = 0;
-    dBm_u txPowerMaxMimo = 0;
+    dBm_u txPowerMaxSiso{0};
+    dBm_u txPowerMaxMimo{0};
     bool powerRestricted = false;
     // Fetch my BSS color
     Ptr<HeConfiguration> heConfiguration = m_device->GetHeConfiguration();
     NS_ASSERT(heConfiguration);
-    uint8_t bssColor = heConfiguration->GetBssColor();
+    uint8_t bssColor = heConfiguration->m_bssColor;
     NS_LOG_DEBUG("My BSS color " << (uint16_t)bssColor << " received frame "
                                  << (uint16_t)params.bssColor);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/obss-pd-algorithm.h ns-3.44/src/wifi/model/he/obss-pd-algorithm.h
--- ns-3.43/src/wifi/model/he/obss-pd-algorithm.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/obss-pd-algorithm.h	2025-03-09 16:55:49.791372500 -0700
@@ -23,8 +23,8 @@
 class WifiNetDevice;
 
 /**
- * \brief OBSS PD algorithm interface
- * \ingroup wifi
+ * @brief OBSS PD algorithm interface
+ * @ingroup wifi
  *
  * This object provides the interface for all OBSS_PD algorithms
  * and is designed to be subclassed.
@@ -37,26 +37,26 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
      * Connect the WifiNetDevice and setup eventual callbacks.
      *
-     * \param device the WifiNetDevice
+     * @param device the WifiNetDevice
      */
     virtual void ConnectWifiNetDevice(const Ptr<WifiNetDevice> device);
 
     /**
      * Reset PHY to IDLE.
-     * \param params HeSigAParameters causing PHY reset
+     * @param params HeSigAParameters causing PHY reset
      */
     void ResetPhy(HeSigAParameters params);
 
     /**
-     * \param params the HE-SIG-A parameters
+     * @param params the HE-SIG-A parameters
      *
      * Evaluate the receipt of HE-SIG-A.
      */
@@ -65,11 +65,11 @@
     /**
      * TracedCallback signature for OBSS_PD reset events.
      *
-     * \param [in] bssColor The BSS color of frame triggering the reset
-     * \param [in] rssiDbm The RSSI (dBm) of frame triggering the reset
-     * \param [in] powerRestricted Whether a TX power restriction is triggered
-     * \param [in] txPowerMaxDbmSiso The SISO TX power restricted level (dBm)
-     * \param [in] txPowerMaxDbmMimo The MIMO TX power restricted level (dBm)
+     * @param [in] bssColor The BSS color of frame triggering the reset
+     * @param [in] rssiDbm The RSSI (dBm) of frame triggering the reset
+     * @param [in] powerRestricted Whether a TX power restriction is triggered
+     * @param [in] txPowerMaxDbmSiso The SISO TX power restricted level (dBm)
+     * @param [in] txPowerMaxDbmMimo The MIMO TX power restricted level (dBm)
      */
     typedef void (*ResetTracedCallback)(uint8_t bssColor,
                                         double rssiDbm,
@@ -78,11 +78,11 @@
                                         double txPowerMaxDbmMimo);
 
     /**
-     * \param level the current OBSS PD level
+     * @param level the current OBSS PD level
      */
     void SetObssPdLevel(dBm_u level);
     /**
-     * \return the current OBSS PD level
+     * @return the current OBSS PD level
      */
     dBm_u GetObssPdLevel() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.cc	2025-03-09 16:55:49.791372500 -0700
@@ -9,9 +9,9 @@
 #include "rr-multi-user-scheduler.h"
 
 #include "he-configuration.h"
-#include "he-frame-exchange-manager.h"
 #include "he-phy.h"
 
+#include "ns3/eht-frame-exchange-manager.h"
 #include "ns3/log.h"
 #include "ns3/wifi-acknowledgment.h"
 #include "ns3/wifi-mac-queue.h"
@@ -192,7 +192,7 @@
     txVector.SetPreambleType(WIFI_PREAMBLE_HE_TB);
     txVector.SetChannelWidth(m_allowedWidth);
     txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
-    txVector.SetBssColor(heConfiguration->GetBssColor());
+    txVector.SetBssColor(heConfiguration->m_bssColor);
 
     // iterate over the associated stations until an enough number of stations is identified
     auto staIt = m_staListUl.begin();
@@ -363,6 +363,21 @@
         m_apMac->GetWifiRemoteStationManager(m_linkId)->GetRtsTxVector(m_triggerMacHdr.GetAddr1(),
                                                                        m_allowedWidth);
 
+    // If this BSRP TF is an ICF, we need to add padding and adjust the TXVECTOR
+    if (auto ehtFem =
+            DynamicCast<EhtFrameExchangeManager>(m_apMac->GetFrameExchangeManager(m_linkId)))
+    {
+        auto prevPaddingSize = m_trigger.GetPaddingSize();
+        ehtFem->SetIcfPaddingAndTxVector(m_trigger, m_txParams.m_txVector);
+        // serialize again if padding has been added
+        if (m_trigger.GetPaddingSize() != prevPaddingSize)
+        {
+            auto packet = Create<Packet>();
+            packet->AddHeader(m_trigger);
+            item = Create<WifiMpdu>(packet, item->GetHeader());
+        }
+    }
+
     if (!GetHeFem(m_linkId)->TryAddMpdu(item, m_txParams, m_availableTime))
     {
         // sending the BSRP Trigger Frame is not possible, hence return NO_TX. In
@@ -373,7 +388,7 @@
     }
 
     // Compute the time taken by each station to transmit 8 QoS Null frames
-    Time qosNullTxDuration = Seconds(0);
+    Time qosNullTxDuration;
     for (const auto& userInfo : m_trigger)
     {
         Time duration = WifiPhy::CalculateTxDuration(GetMaxSizeOfQosNullAmpdu(m_trigger),
@@ -383,6 +398,9 @@
         qosNullTxDuration = Max(qosNullTxDuration, duration);
     }
 
+    NS_ASSERT(m_txParams.m_txDuration.has_value());
+    m_triggerTxDuration = m_txParams.m_txDuration.value();
+
     if (m_availableTime != Time::Min())
     {
         // TryAddMpdu only considers the time to transmit the Trigger Frame
@@ -390,7 +408,6 @@
         NS_ASSERT(m_txParams.m_acknowledgment &&
                   m_txParams.m_acknowledgment->acknowledgmentTime.has_value() &&
                   m_txParams.m_acknowledgment->acknowledgmentTime->IsZero());
-        NS_ASSERT(m_txParams.m_txDuration.has_value());
 
         if (*m_txParams.m_protection->protectionTime + *m_txParams.m_txDuration // BSRP TF tx time
                 + m_apMac->GetWifiPhy(m_linkId)->GetSifs() + qosNullTxDuration >
@@ -503,13 +520,15 @@
         return NO_TX;
     }
 
+    NS_ASSERT(m_txParams.m_txDuration.has_value());
+    m_triggerTxDuration = m_txParams.m_txDuration.value();
+
     if (m_availableTime != Time::Min())
     {
         // TryAddMpdu only considers the time to transmit the Trigger Frame
         NS_ASSERT(m_txParams.m_protection && m_txParams.m_protection->protectionTime.has_value());
         NS_ASSERT(m_txParams.m_acknowledgment &&
                   m_txParams.m_acknowledgment->acknowledgmentTime.has_value());
-        NS_ASSERT(m_txParams.m_txDuration.has_value());
 
         maxDuration = Min(maxDuration,
                           m_availableTime - *m_txParams.m_protection->protectionTime -
@@ -523,7 +542,7 @@
     }
 
     // Compute the time taken by each station to transmit a frame of maxBufferSize size
-    Time bufferTxTime = Seconds(0);
+    Time bufferTxTime;
     for (const auto& userInfo : m_trigger)
     {
         Time duration = WifiPhy::CalculateTxDuration(maxBufferSize,
@@ -542,7 +561,7 @@
     {
         // maxDuration may be a too short time. If it does not allow any station to
         // transmit at least m_ulPsduSize bytes, give up the UL MU transmission for now
-        Time minDuration = Seconds(0);
+        Time minDuration;
         for (const auto& userInfo : m_trigger)
         {
             Time duration =
@@ -583,6 +602,78 @@
 }
 
 void
+RrMultiUserScheduler::UpdateTriggerFrameAfterProtection(uint8_t linkId,
+                                                        CtrlTriggerHeader& trigger,
+                                                        WifiTxParameters& txParams) const
+{
+    NS_LOG_FUNCTION(this << linkId << &txParams);
+
+    // remove unprotected EMLSR clients, unless this is a BSRP TF (which acts as ICF)
+    if (trigger.IsBsrp())
+    {
+        NS_LOG_INFO("BSRP TF is an ICF for unprotected EMLSR clients");
+        return;
+    }
+
+    NS_LOG_INFO("Checking unprotected EMLSR clients");
+    RemoveRecipientsFromTf(linkId, trigger, txParams, m_isUnprotectedEmlsrClient);
+}
+
+void
+RrMultiUserScheduler::UpdateDlMuAfterProtection(uint8_t linkId,
+                                                WifiPsduMap& psduMap,
+                                                WifiTxParameters& txParams) const
+{
+    NS_LOG_FUNCTION(this << linkId << &txParams);
+
+    NS_LOG_INFO("Checking unprotected EMLSR clients");
+    RemoveRecipientsFromDlMu(linkId, psduMap, txParams, m_isUnprotectedEmlsrClient);
+}
+
+Time
+RrMultiUserScheduler::GetExtraTimeForBsrpTfDurationId(uint8_t linkId) const
+{
+    auto phy = m_apMac->GetWifiPhy(linkId);
+    BlockAckType baType(BlockAckType::MULTI_STA);
+    uint16_t aid{0};
+    Mac48Address staAddress;
+
+    // we assume that a Basic Trigger Frame is sent after a BSRP Trigger Frame. In order to
+    // compute the TX duration of the Multi-STA BlockAck, we need to find the bitmap length
+    // for each STA solicited by the Trigger Frame
+    for (const auto& userInfo : m_trigger)
+    {
+        aid = userInfo.GetAid12();
+        auto it = m_apMac->GetStaList(linkId).find(aid);
+        NS_ASSERT(it != m_apMac->GetStaList(linkId).cend());
+        staAddress = it->second;
+
+        // find a TID for which a BA agreement exists with the given originator
+        uint8_t tid = 0;
+        while (tid < 8 && !m_apMac->GetBaAgreementEstablishedAsRecipient(staAddress, tid))
+        {
+            ++tid;
+        }
+        NS_ASSERT_MSG(tid < 8, "No Block Ack agreement established with originator " << staAddress);
+
+        baType.m_bitmapLen.push_back(
+            m_apMac->GetBaTypeAsRecipient(staAddress, tid).m_bitmapLen.at(0));
+    }
+
+    NS_ASSERT_MSG(aid != 0, "No User Info field in the Trigger Frame");
+
+    auto multiStaBaTxVector =
+        GetWifiRemoteStationManager(linkId)->GetBlockAckTxVector(staAddress,
+                                                                 m_trigger.GetHeTbTxVector(aid));
+
+    auto multiStaBaDuration = WifiPhy::CalculateTxDuration(GetBlockAckSize(baType),
+                                                           multiStaBaTxVector,
+                                                           phy->GetPhyBand());
+
+    return m_triggerTxDuration + m_defaultTbPpduDuration + multiStaBaDuration + 3 * phy->GetSifs();
+}
+
+void
 RrMultiUserScheduler::NotifyStationAssociated(uint16_t aid, Mac48Address address)
 {
     NS_LOG_FUNCTION(this << aid << address);
@@ -701,7 +792,7 @@
     m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_HE_MU);
     m_txParams.m_txVector.SetChannelWidth(m_allowedWidth);
     m_txParams.m_txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
-    m_txParams.m_txVector.SetBssColor(heConfiguration->GetBssColor());
+    m_txParams.m_txVector.SetBssColor(heConfiguration->m_bssColor);
 
     // The TXOP limit can be exceeded by the TXOP holder if it does not transmit more
     // than one Data or Management frame in the TXOP and the frame is not in an A-MPDU
@@ -714,7 +805,7 @@
     m_candidates.clear();
 
     std::vector<uint8_t> ruAllocations;
-    const std::size_t numRuAllocs = m_txParams.m_txVector.GetChannelWidth() / 20;
+    const auto numRuAllocs = Count20MHzSubchannels(m_txParams.m_txVector.GetChannelWidth());
     ruAllocations.resize(numRuAllocs);
     NS_ASSERT((m_candidates.size() % numRuAllocs) == 0);
 
